diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/res/XmlBlock.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/res/XmlBlock.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/res/XmlBlock.java	2017-09-27 02:07:48.947736110 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/res/XmlBlock.java	2017-01-29 02:51:19.633888000 +0900
@@ -35,13 +35,15 @@
     private static final boolean DEBUG=false;
 
     public XmlBlock(byte[] data) {
-        mAssets = null;
+        mABC = null;
+    	mAssets = null;
         mNative = nativeCreate(data, 0, data.length);
         mStrings = new StringBlock(nativeGetStringBlock(mNative), false);
     }
 
     public XmlBlock(byte[] data, int offset, int size) {
-        mAssets = null;
+    	mABC = null;
+    	mAssets = null;
         mNative = nativeCreate(data, offset, size);
         mStrings = new StringBlock(nativeGetStringBlock(mNative), false);
     }
@@ -477,11 +479,22 @@
      *  of this newly creating XmlBlock.
      */
     XmlBlock(AssetManager assets, long xmlBlock) {
-        mAssets = assets;
+        mABC = null;
+    	mAssets = assets;
+        mNative = xmlBlock;
+        mStrings = new StringBlock(nativeGetStringBlock(xmlBlock), false);
+    }
+    
+    // ADDED FOR COLLABOROID
+    XmlBlock(ABCManager abc, long xmlBlock) {
+        mABC = abc;
+        mAssets = null;
         mNative = xmlBlock;
         mStrings = new StringBlock(nativeGetStringBlock(xmlBlock), false);
     }
+    
 
+    private final ABCManager mABC;
     private final AssetManager mAssets;
     private final long mNative;
     /*package*/ final StringBlock mStrings;
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/provider/Settings.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/provider/Settings.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/provider/Settings.java	2017-09-27 02:07:49.015736109 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/provider/Settings.java	2017-01-29 02:51:19.389885000 +0900
@@ -3870,6 +3870,8 @@
             MOVED_TO_GLOBAL.add(Settings.Global.DEFAULT_DNS_SERVER);
             MOVED_TO_GLOBAL.add(Settings.Global.PREFERRED_NETWORK_MODE);
             MOVED_TO_GLOBAL.add(Settings.Global.WEBVIEW_DATA_REDUCTION_PROXY_KEY);
+            
+            
         }
 
         /** @hide */
@@ -7695,6 +7697,10 @@
          * @hide
          */
         public static final String LTE_SERVICE_FORCED = "lte_service_forced";
+        
+        // ADDED FOR COLLABOROID
+        public static final String COLLABOROID_ON = "collaboroid_on";
+        public static final String TASKEXECUTOR_ON = "taskexecutor_on";
 
         /**
          * Settings to backup. This is here so that it's in the same place as the settings
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/collaboroid/IGeneralMessageListener.aidl SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/collaboroid/IGeneralMessageListener.aidl
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/collaboroid/IGeneralMessageListener.aidl	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/collaboroid/IGeneralMessageListener.aidl	2016-11-01 17:36:40.394409000 +0900
@@ -0,0 +1,6 @@
+package android.service.collaboroid;
+
+oneway interface IGeneralMessageListener
+{
+	void onMessageReceived(String message);
+}
\ No newline at end of file
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/devicemanagement/Device.aidl SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/devicemanagement/Device.aidl
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/devicemanagement/Device.aidl	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/devicemanagement/Device.aidl	2016-11-04 02:26:40.000000000 +0900
@@ -0,0 +1,3 @@
+package android.service.devicemanagement;
+
+parcelable Device;
\ No newline at end of file
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/devicemanagement/Device.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/devicemanagement/Device.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/devicemanagement/Device.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/devicemanagement/Device.java	2017-07-06 19:18:24.584237000 +0900
@@ -0,0 +1,136 @@
+package android.service.devicemanagement;
+
+import android.os.Parcel;
+import android.os.Parcelable;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+
+public class Device implements Parcelable
+{
+	public static final int RESOURCE_TYPE_TOUCH = 0;
+	public static final int RESOURCE_TYPE_KEY = 1;
+	public static final int RESOURCE_TYPE_SENSOR = 2;
+	public static final int RESOURCE_TYPE_LOCATION = 3;
+	public static final int RESOURCE_TYPE_VIDEO = 4;
+	public static final int RESOURCE_TYPE_AUDIO = 5;
+	public static final int RESOURCE_TYPE_VIBRATOR = 6;
+	public static final int RESOURCE_TYPE_REMOTE_ACTIVITY = 7;
+
+	public static final int RESOURCE_TYPE_SIZE = 8;
+
+	public static final String[] ResourceNames = {"Touch", "Key", "Sensor", "Location", "Video", "Audio", "Vibrator", "R. Activity"};
+
+	public final int SYSTEM_SERVICE_LIST = 1;
+	public final int TASK_EXECUTOR_LIST = 2;
+
+	public String ipaddress;
+	public String idleCpu;
+	public String deviceName;
+	public int isSystemServiceOn = -1;
+	public int isTaskExecutorOn = -1;
+	public int[] askedResources;
+	public int[] allowedResources;
+
+	public String HaveDexFiles;
+
+	//samd
+	public List<String> dexTable;
+	public List<String> resourceTable;
+
+	public Device(String ipaddress, String idleCpu, String name, int isSystemServiceOn, int isTaskExecutorOn) {
+		updateDevice(ipaddress, idleCpu, name, isSystemServiceOn, isTaskExecutorOn);
+//		this.ipaddress = ipaddress;
+//		this.idleCpu = idleCpu;
+//		this.isSystemServiceOn = isSystemServiceOn;
+//		this.isTaskExecutorOn = isTaskExecutorOn;
+	}
+
+	public Device() {
+		// TODO Auto-generated constructor stub
+		initDevice();
+	}
+
+	public void initDevice(){
+		this.ipaddress = "";
+		this.idleCpu = "";
+		this.deviceName = "";
+		this.isSystemServiceOn = -1;
+		this.isTaskExecutorOn = -1;
+		this.askedResources = new int[RESOURCE_TYPE_SIZE];
+		this.allowedResources = new int[RESOURCE_TYPE_SIZE];
+		this.HaveDexFiles = "";
+		dexTable = new ArrayList<String>();
+		resourceTable = new ArrayList<String>();
+	}
+
+	public String toString() {
+		String result = "ipAddress: " + this.ipaddress
+				+ "idleCPU: " + this.idleCpu
+				+ "SystemServerOn? " + Integer.toString(isSystemServiceOn)
+				+ "TaskExecutorOn? " + Integer.toString(isTaskExecutorOn);
+		return result;
+	}
+
+	public void updateDevice(String ipaddress, String idleCpu, String name, int isSystemServiceOn, int isTaskExecutorOn){
+		initDevice();
+		this.ipaddress = ipaddress;
+		this.idleCpu = idleCpu;
+		this.deviceName = name;
+		this.isSystemServiceOn = isSystemServiceOn;
+		this.isTaskExecutorOn = isTaskExecutorOn;
+	}
+
+	public void setAllowedResources(int[] resources)
+	{
+		allowedResources = resources;
+	}
+
+	public void setAskedResources(int[] resources)
+	{
+		askedResources = resources;
+	}
+
+	@Override
+	public int describeContents() {
+		// TODO Auto-generated method stub
+		return 0;
+	}
+
+	@Override
+	public void writeToParcel(Parcel dest, int flags) {
+		// TODO Auto-generated method stub
+		dest.writeString(ipaddress);
+		dest.writeString(idleCpu);
+		dest.writeString(deviceName);
+		dest.writeInt(isSystemServiceOn);
+		dest.writeInt(isTaskExecutorOn);
+		dest.writeIntArray(askedResources);
+		dest.writeIntArray(allowedResources);
+		dest.writeString(HaveDexFiles);
+		dest.writeStringList(dexTable);
+		dest.writeStringList(resourceTable);
+	}
+	public static final Creator<Device> CREATOR = new Creator<Device>() {
+		public Device createFromParcel(Parcel in) {
+			Device device = new Device();
+			device.ipaddress = in.readString();
+			device.idleCpu = in.readString();
+			device.deviceName = in.readString();
+			device.isSystemServiceOn = in.readInt();
+			device.isTaskExecutorOn = in.readInt();
+			device.askedResources = in.createIntArray();
+			device.allowedResources = in.createIntArray();
+			device.HaveDexFiles = in.readString();
+			in.readStringList(device.dexTable);
+			in.readStringList(device.resourceTable);
+
+			return device;
+		}
+
+		public Device[] newArray(int size) {
+			return new Device[size];
+		}
+	};
+}
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/devicemanagement/DeviceList.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/devicemanagement/DeviceList.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/devicemanagement/DeviceList.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/devicemanagement/DeviceList.java	2017-07-06 18:23:00.550870000 +0900
@@ -0,0 +1,18 @@
+package android.service.devicemanagement;
+
+import java.util.HashMap;
+
+public class DeviceList 
+{
+	private static HashMap<String, Device> devices = new HashMap<String, Device>();
+
+    public static HashMap<String, Device> getDevices() {
+		return devices;
+	}
+
+	public static void setDevices(HashMap<String, Device> devices) {
+		DeviceList.devices = devices;
+	}
+	
+
+}
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/devicemanagement/DeviceManager.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/devicemanagement/DeviceManager.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/devicemanagement/DeviceManager.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/devicemanagement/DeviceManager.java	2017-07-06 20:05:56.335399000 +0900
@@ -0,0 +1,253 @@
+package android.service.devicemanagement;
+
+import java.util.List;
+
+import android.content.Context;
+import android.os.RemoteException;
+import android.os.ServiceManager;
+import android.service.remote.IRemoteService;
+import android.util.Log;
+
+public class DeviceManager {
+	private final IDeviceManagementService mService;
+
+	public DeviceManager(IDeviceManagementService service) {
+		mService = service;
+	}
+
+	public DeviceManager(Context ctx) {
+		mService = IDeviceManagementService.Stub.asInterface(ServiceManager.getService(Context.DEVICE_MANAGEMENT_SERVICE));
+	}
+
+	public DeviceManager() {
+		mService = IDeviceManagementService.Stub.asInterface(ServiceManager.getService(Context.DEVICE_MANAGEMENT_SERVICE));
+	}
+
+	public String recommendDevice(List<Device> peerlist) {
+		try {
+			return mService.recommendDevice(peerlist);
+		} catch (RemoteException e) {
+			e.printStackTrace();
+		}
+		return null;
+
+	}
+
+	public String[] getSystemServiceOnServerList(){
+		try{
+			return mService.getSystemServiceOnServerList();
+		} catch(RemoteException e){
+			e.printStackTrace();
+		}
+		return null;
+	}
+
+	public String[] getTaskExecutorOnServerList(){
+		try{
+			return mService.getTaskExecutorOnServerList();
+		} catch(RemoteException e){
+			e.printStackTrace();
+		}
+		return null;
+	}
+
+	public List<Device> getDeviceList(int kind) {
+		try {
+			return mService.getDeviceList(kind);
+		} catch (RemoteException e) {
+			e.printStackTrace();
+		}
+		return null;
+
+	}
+
+	public void constructCluster(List<Device> devicelist)
+	{
+		try
+		{
+			Log.d("DeviceManager", "in construct!");
+			mService.constructCluster(devicelist);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+	}
+
+	public int getNumofConfiguredDevices()
+	{
+		try
+		{
+			return mService.getNumofConfiguredDevices();
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+		return 0;
+	}
+
+	public Device getDevice(String name)
+	{
+		try
+		{
+			return mService.getDevice(name);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+		return null;
+	}
+
+	public void askResources(List<Device> devicelist) {
+		try
+		{
+			mService.askResources(devicelist);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+	}
+
+	public void allowResources(String deviceName, int[] allowedResources)
+	{
+		try
+		{
+			mService.allowResources(deviceName, allowedResources);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+	}
+
+	//collaboroid
+	public String getHaveDexFiles(int deviceNum)
+	{
+		String temp = null;
+		try
+		{
+			Log.d("SBJSBJ", "SBJSBJ getHaveDexFiles [DeviceManager]");
+			temp = mService.getHaveDexFiles(deviceNum);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+		if(temp==null){
+			temp="sbjsbj";
+		}
+		return temp;
+	}
+
+	public void addHaveDexFiles(int deviceNum, String dexFiles)
+	{
+		try
+		{
+			mService.addHaveDexFiles(deviceNum, dexFiles);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+	}
+
+	//samd
+	//initialize
+	/*
+	public void initialARTable(int deviceNum){
+		try
+		{
+			mService.initialARTable(deviceNum);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+	}
+
+	//add resource dex
+	public void addDexFile(int deviceNum, List<String> dexString){
+		try
+		{
+			mService.addDexFile(deviceNum, dexString);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+	}
+	public void addResourceFile(int deviceNum, List<String> resourceString){
+		try
+		{
+			mService.addResourceFile(deviceNum, resourceString);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+	}
+
+	//get resource dex
+	public List<String> getDexFile(int deviceNum){
+		List<String> temp = null;
+		try
+		{
+			Log.d("SBJSBJ", "SBJSBJ getHaveDexFiles [DeviceManager]");
+			temp = mService.getDexFile(deviceNum);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+
+		return temp;
+	}
+
+	public List<String> getResourceFile(int deviceNum){
+		List<String> temp = null;
+		try
+		{
+			Log.d("SBJSBJ", "SBJSBJ getHaveDexFiles [DeviceManager]");
+			temp = mService.getResourceFile(deviceNum);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+
+		return temp;
+	}
+	public List<String> checkDexFile(int deviceNum, List<String> dexList){
+		List<String> temp = null;
+		try
+		{
+			Log.d("SBJSBJ", "SBJSBJ getHaveDexFiles [DeviceManager]");
+			temp = mService.checkDexFile(deviceNum);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+
+		return temp;
+	}
+
+	public List<String> checkResourceFile(int deviceNum, List<String> resourceList){
+		List<String> temp = null;
+		try
+		{
+			Log.d("SBJSBJ", "SBJSBJ getHaveDexFiles [DeviceManager]");
+			temp = mService.checkResourceFile(deviceNum);
+		}
+		catch(RemoteException e)
+		{
+			e.printStackTrace();
+		}
+		return temp;
+	}
+	*/
+
+}
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/devicemanagement/IDeviceManagementService.aidl SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/devicemanagement/IDeviceManagementService.aidl
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/devicemanagement/IDeviceManagementService.aidl	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/devicemanagement/IDeviceManagementService.aidl	2017-07-06 20:13:16.191688000 +0900
@@ -0,0 +1,34 @@
+package android.service.devicemanagement;
+
+import android.service.devicemanagement.Device;
+
+interface IDeviceManagementService {
+	void initDevices();
+	String recommendDevice(in List<Device> devicelist); 
+	List<Device> getDeviceList(int kind);
+	String[] getSystemServiceOnServerList();
+	String[] getTaskExecutorOnServerList();
+	
+	int getNumofConfiguredDevices();
+    Device getDevice(String name);
+    void constructCluster(in List<Device> devicelist);
+    
+    void askResources(in List<Device> devicelist);
+    void allowResources(String deviceName, in int[] allowedResources);
+    void showRequestDialog(String deviceName, String deviceIP, in int[] askedResources);
+	
+	boolean isAllowedForResource(String device, int resource);
+
+	//collaboroid
+	String getHaveDexFiles(int deviceNum);
+	void addHaveDexFiles(int deviceNum, String dexFiles);
+	/*
+	void initialARTable(int deviceNum);
+	void addDexFile(int deviceNum,in List<String> dexString);
+	void addResourceFile(int deviceNum,in List<String> resourceString);
+	List<String> getDexFile(int deviceNum);
+	List<String> getResourceFile(int deviceNum);
+	List<String> checkDexFile(int deviceNum, in List<String> dexList);
+    List<String> checkResourceFile(int deviceNum,in List<String> resourceList);
+    */
+}
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/distribute/IDistributedComputingService.aidl SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/distribute/IDistributedComputingService.aidl
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/distribute/IDistributedComputingService.aidl	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/distribute/IDistributedComputingService.aidl	2016-11-01 17:36:40.394409000 +0900
@@ -0,0 +1,14 @@
+package android.service.distribute;
+
+interface IDistributedComputingService
+{
+	void startJobManager(String ip);
+	void stopJobManager();
+	
+	void startTaskExecutor();
+	void stopTaskExecutor();
+	
+	int sum(int start, int end);
+	
+	void testOperation();
+}
\ No newline at end of file
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/remote/DexCode.aidl SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/remote/DexCode.aidl
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/remote/DexCode.aidl	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/remote/DexCode.aidl	2017-07-28 05:14:16.693859000 +0900
@@ -0,0 +1,3 @@
+package android.service.remote;
+
+parcelable DexCode;
\ No newline at end of file
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/remote/IRemoteService.aidl SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/remote/IRemoteService.aidl
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/remote/IRemoteService.aidl	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/remote/IRemoteService.aidl	2017-09-15 10:56:23.527884000 +0900
@@ -0,0 +1,80 @@
+package android.service.remote;
+
+import android.service.remote.RemoteRequest;
+
+import android.service.devicemanagement.Device;
+
+import android.service.collaboroid.IGeneralMessageListener;
+import android.view.MotionEvent;
+import android.view.KeyEvent;
+import android.location.Location;
+import android.os.Bundle;
+
+interface IRemoteService
+{
+	boolean startServer();
+	boolean stopServer();
+	
+	void setConfiguration();
+	void setEnabled(boolean isEnabled);
+	
+	boolean isServerOn();
+	
+//	void connectToServer();
+	boolean connectToServer(String ip);
+	void disconnectToServer();
+	void initConnections();
+	List<String> getClientIPs();
+	List<String> getServerIPs();
+	void sendAllMusic(int sampleSize, in byte[] to_send, long presentationTime);
+	void sendAllrequest(in RemoteRequest request);
+	
+	boolean sendResourceRequests(in List<Device> requestDeviceList);
+	boolean isAllowedForResource(String deviceName, String deviceIP, in int[] resources);
+	boolean respondAllowedResources(String deviceIP, in int[] resources);
+	
+	boolean sendRequest(in RemoteRequest request);
+//	void sendSensorRequest(in SensorEventQueue2 queue);
+
+	// for MotionEvent
+	void sendMotionEvent(in MotionEvent event);
+	
+	// for KeyEvent
+	void sendKeyEvent(in KeyEvent event);
+	
+	// for SensorEvent
+//	boolean setRemoteSensorOn(boolean flag, SensorEventListener listener);
+	void addSensorHandle(int type, int handle);
+	void removeSensorHandle(int type);
+	void sendSensorEvent(int type, int sensor, in float[] values, int accuracy, long timestamp);
+	
+	// for API
+	void playMusic();
+	
+	// for evaluations
+	void testVibrate();
+	void testMusic();
+	void testVideo();
+	void testTouch();
+	void testKey();
+	void testSensor();
+	void testLocation();
+	void requestMotionEvents();
+
+
+
+	//16.12.07
+	void refreshDevices();
+
+	void sendMusicData(int sampleSize, in byte[] to_send, long presentationTime);
+	
+	int getVideoPlayers();
+	void sendVideoSignal(int vport);
+	
+	void sendLocation(in Location location);
+
+//	Object sendRountTripRequest(in RemoteRequest request);
+
+	void registerListener(IGeneralMessageListener listener);
+	void unregisterListener(IGeneralMessageListener listener);
+}
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/remote/RemoteRequest.aidl SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/remote/RemoteRequest.aidl
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/remote/RemoteRequest.aidl	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/remote/RemoteRequest.aidl	2016-11-01 17:36:40.394409000 +0900
@@ -0,0 +1,3 @@
+package android.service.remote;
+
+parcelable RemoteRequest;
\ No newline at end of file
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/remote/ResourceAapt.aidl SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/remote/ResourceAapt.aidl
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/remote/ResourceAapt.aidl	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/remote/ResourceAapt.aidl	2017-07-28 05:12:52.445917000 +0900
@@ -0,0 +1,3 @@
+package android.service.remote;
+
+parcelable ResourceAapt;
\ No newline at end of file
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/remote/SdPackage.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/remote/SdPackage.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/remote/SdPackage.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/remote/SdPackage.java	2017-01-29 02:51:19.453886000 +0900
@@ -0,0 +1,79 @@
+package android.service.remote;
+
+import java.io.Serializable;
+
+
+
+public class SdPackage implements Serializable{
+
+	private int sampleSize = 0;
+	private byte[] sampleData;
+	private long presentationTime = 0;
+	private String mime = "audio/mpeg";
+	private int bitrate = 0;
+	private int channels = 0;
+	private int sampleRate = 0;
+	private long duration = 0;
+	private byte[] csd0;
+	/**
+	 * 
+	 */
+	private static final long serialVersionUID = 1L;
+	
+	public SdPackage(int sampleSize, byte[] sampleData, long presentationTime){
+		this.sampleSize = sampleSize;
+		this.sampleData = sampleData;
+		this.presentationTime = presentationTime; 
+	}
+	
+	public SdPackage(String _mime, int _bitrate, int _channels, int _sampleRate, long _duration, byte[] _csd0){
+		this.mime = _mime;
+		this.bitrate = _bitrate;
+		this.channels = _channels;
+		this.sampleRate = _sampleRate;
+		this.duration = _duration;
+		this.csd0 = _csd0;
+	}
+	
+	public String getMime(){
+		return this.mime;
+	}
+	
+	public int getBitrate(){
+		return this.bitrate;
+	}
+	
+	public int getChannels(){
+		return this.channels;
+	}
+	
+	public int getSampleRate(){
+		return this.sampleRate;
+	}
+
+	public int getSampleSize(){
+		return this.sampleSize;
+	}
+	
+	public long getDuration(){
+		return this.duration;
+	}
+	
+	public byte[] get_csd0(){
+		return this.csd0;
+	}
+	
+	public byte[] getSampleData(){
+		return this.sampleData;
+	}
+	
+	public long getPresentationTime(){
+		return this.presentationTime;
+	}
+	
+	@Override
+	public String toString(){
+		 return this.sampleSize+" is sampleSize,  " + this.sampleData + " is sampleData,  " + this.presentationTime + " is prest. time"; 
+	}
+	
+}
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/remote/vData.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/remote/vData.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/remote/vData.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/remote/vData.java	2017-01-29 02:51:19.461886000 +0900
@@ -0,0 +1,112 @@
+package android.service.remote;
+
+import java.io.Serializable;
+
+import android.os.Parcel;
+import android.os.Parcelable;
+
+public class vData implements Serializable{
+
+	private String mime = "video/avc";
+	private int width = 0;
+	private int height = 0;
+	private byte[] csd0 = null;
+	private byte[] csd1 = null;
+	
+	public int sampleSize = 0;
+	public byte[] sampleData;
+	public long presentationTime = 0;
+	
+	private static final long serialVersionUID = 1L;
+	
+	/**
+	 * 
+	 */
+	public vData(){
+		
+	}
+	
+	/**
+	 * 
+	 */
+	public vData(int _sampleSize, byte[] _sampleData, long _presentationTime){
+		sampleSize = _sampleSize;
+		sampleData = _sampleData;
+		presentationTime = _presentationTime;
+	}
+	
+	
+	/**
+	 * 
+	 */
+	public void setMediaFormat(String _mime, int _width, int _height, byte[] _csd0, byte[] _csd1){
+		mime = _mime;
+		width = _width;
+		height = _height;
+		csd0 = _csd0;
+		csd1 = _csd1;
+	}
+
+	/**
+	 * 
+	 */
+	public int getSampleSize(){
+		return sampleSize;
+	}
+
+	/**
+	 * 
+	 */
+	public byte[] getSampleData(){
+		return sampleData;
+	}
+
+	/**
+	 * 
+	 */
+	public long getPresentationTime(){
+		return presentationTime;
+	}	
+	/**
+	 * 
+	 */
+	public String getMime(){
+		return mime;
+	}
+	
+	/**
+	 * 
+	 */
+	public int getWidth(){
+		return width;
+	}
+	
+	/**
+	 * 
+	 */
+	public int getHeight(){
+		return height;
+	}
+
+	/**
+	 * 
+	 */
+	public byte[] get_csd0(){
+		return csd0;
+	}
+
+	/**
+	 * 
+	 */
+	public byte[] get_csd1(){
+		return csd1;
+	}
+
+	
+	@Override
+	public String toString() {
+		return sampleSize + " is sampleSize,  " + sampleData
+				+ " is sampleData,  " + presentationTime + " is prest. time";
+	}
+	
+}
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/samd/ISAMDListener.aidl SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/samd/ISAMDListener.aidl
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/samd/ISAMDListener.aidl	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/samd/ISAMDListener.aidl	2017-09-21 13:53:14.619913000 +0900
@@ -0,0 +1,7 @@
+package android.service.samd;
+
+import android.service.samd.SAMDMessage;
+
+oneway interface ISAMDListener {
+    void onSAMDMsg(in SAMDMessage message);
+}
\ No newline at end of file
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/samd/ISAMDService.aidl SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/samd/ISAMDService.aidl
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/samd/ISAMDService.aidl	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/samd/ISAMDService.aidl	2017-09-22 00:35:13.873247000 +0900
@@ -0,0 +1,44 @@
+package android.service.samd;
+
+import android.service.remote.RemoteRequest;
+import android.service.samd.ISAMDListener;
+
+import android.os.Bundle;
+
+interface ISAMDService
+{
+	//collaboroid
+    //17.03.02
+    boolean initialARTable(String appName);
+    boolean initialARTableD(int deviceNum, String appName);
+
+    void preSendDex(String currentActivity, String packageName);
+
+    void sendDexActivityD(int deviceNum, String DexFile);
+    void sendDexActivity(String multiDexFile);
+
+	void sendResourcesToLocal(in List<String> resourceFiles);
+	void sendResourcesToRemote(in List<String> resourceFiles, String toSendActivityName);
+	void sendResourcesToRemoteD(int deviceNum, in List<String> resourceFiles, String toSendActivityName);
+
+	void launchActivity(String toSendActivityName);
+	void launchActivityD(int deviceNum, String toSendActivityName);
+	void launchActivityWithRes(String toSendActivityName, in List<String> resourceFiles);
+	void launchActivityWithResD(int deviceNum, String toSendActivityName, in List<String> resourceFiles);
+
+	void sendMessageToRemoteD(int deviceNum, String msg);
+    void sendMessageToRemote(String msg);
+    void sendMessageToLocal(String msg);
+
+    int getRemoteDeviceCount();
+    int getRemoteDeviceNumber();
+    String getCurrentAppName();
+    //samd listener
+    oneway void requestSAMDListener(in ISAMDListener listener);
+    //sendAPK Test
+    void sendAPKFile(String dir);
+    //reviseApp
+    void ConvertDex(String appName);
+    //popup
+    void popUpActivity(String activityName);
+}
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/samd/SAMDListener.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/samd/SAMDListener.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/samd/SAMDListener.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/samd/SAMDListener.java	2017-09-21 13:53:14.619913000 +0900
@@ -0,0 +1,8 @@
+package android.service.samd;
+
+/**
+ * Created by sbj on 16. 12. 15.
+ */
+public interface SAMDListener{
+    void onSAMDMsg(SAMDMessage message);
+}
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/service/samd/SAMDMessage.aidl SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/samd/SAMDMessage.aidl
--- Android_6.0.1_r11/frameworks/base/core/java/android/service/samd/SAMDMessage.aidl	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/service/samd/SAMDMessage.aidl	2017-09-15 11:32:07.302027000 +0900
@@ -0,0 +1,3 @@
+package android.service.samd;
+
+parcelable SAMDMessage;
\ No newline at end of file
